%global momorel 11

%global qtdir %{_libdir}/qt3
%global qtver 3.3.3

Summary: A personal video recorder (PVR) application.
Name: mythtv
Version: 0.16
Release: %{momorel}m
URL: http://www.mythtv.org/
License: GPL
Group: Applications/Multimedia
%NoSource 0 http://www.mythtv.org/mc/%{name}-%{version}.tar.bz2 0eba17cf64c96ea3ead23e7e15419cc0
Source1: mythbackend.sysconfig.in
Source2: mythbackend.init.in
Source3: mythbackend.logrotate.in
Source4: mythtv.png
Source5: mythtv.desktop
Source6: mythfrontend.png
Source7: mythfrontend.desktop
Source8: mythepg.png
Source9: mythepg.desktop
Source10: mythprogfind.png
Source11: mythprogfind.desktop
Source100: mythtv-doc.configure.ac
Source101: mythtv-doc.Makefile.am
Patch0: http://www.mythtv.org/mc/tvformat.fix.0.13.diff
Patch1: mythtv-0.16-lib64.patch
Patch2: mythtv-0.16-gcc41.patch
Patch3: mythtv-0.16-libpostproc.patch
Patch4: mythtv-0.16-i386_dsputil_mmx.patch
Patch5: libavcodec-cvs-ppc-altivec-gcc4.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildRequires: mesa-libGL-devel
BuildRequires: libICE-devel, libSM-devel, libX11-devel, libXcursor-devel
BuildRequires: libXext-devel, libXft-devel, libXinerama-devel, libXmu-devel
BuildRequires: libXrandr-devel, libXrender-devel, libXv-devel libXxf86vm-devel
BuildRequires: freetype2-devel, fontconfig-devel, truetype-fonts-ja
BuildRequires: lame-devel, mysql-devel, alsa-lib, lirc-devel
BuildRequires: qt-devel >= %{qtver}
BuildRequires: sgml-tools, autoconf, automake
BuildRequires: desktop-file-utils
# for Symbolic links
Requires: qt >= %{qtver}
Requires: libmyth = %{version}
PreReq: chkconfig, shadow-utils

%description
MythTV implements the following PVR features, and more, with a
unified graphical interface:

 - Basic 'live-tv' functionality. Pause/Fast Forward/Rewind "live" TV.
 - Video compression using RTjpeg or MPEG-4
 - Program listing retrieval using XMLTV
 - Themable, semi-transparent on-screen display
 - Electronic program guide
 - Scheduled recording of TV programs
 - Resolution of conflicts between scheduled recordings
 - Basic video editing

%package -n libmyth
Summary: Library providing mythtv support.
Group: System Environment/Libraries
Requires: mysql, qt-MySQL

%description -n libmyth
Common library code for MythTV and add-on modules (development)
MythTV provides a unified graphical interface for recording and viewing
television programs.  Refer to the mythtv package for more information.

%package -n libmyth-devel
Summary: Development files for libmyth.
Group: Development/Libraries
Requires: libmyth = %{version}, alsa-lib, lirc-devel

%description -n libmyth-devel
This package contains the header files and libraries for developing
add-ons for mythtv.

%package frontend
Summary: Client component of mythtv (a PVR).
Group: Applications/Multimedia
Requires: libmyth = %{version}, mythtv = %{version}

%description frontend
MythTV provides a unified graphical interface for recording and viewing
television programs.  Refer to the mythtv package for more information.

This package contains only the client software, which provides a
front-end for playback and configuration.  It requires access to a
mythtv-backend installation, either on the same system or one
reachable via the network.

%package backend
Summary: Server component of mythtv (a PVR).
Group: Applications/Multimedia
Requires: xmltv-grabbers >= 0.5.21
Requires: libmyth = %{version}, mythtv = %{version}

%description backend
MythTV provides a unified graphical interface for recording and viewing
television programs.  Refer to the mythtv package for more information.

This package contains only the server software, which provides video
and audio capture and encoding services.  In order to be useful, it
requires a mythtv-frontend installation, either on the same system or
one reachable via the network.

%prep
%setup -q
#%%patch0 -p0 -b .tvformat.
%if %{_lib} == "lib64"
%patch1 -p1 -b .lib64~
%endif
%patch2 -p1 -b .gcc41~
%patch3 -p1 -b .libpostproc~
%patch4 -p1 -b .i386_dsputil_mmx~
( cd libs
%patch5 -p1 -b .ppc-altivec-gcc4~
)


cp -a %{SOURCE1} %{SOURCE2} %{SOURCE3} .
for file in mythbackend.init \
            mythbackend.sysconfig \
            mythbackend.logrotate; do
  sed -e's|@logdir@|/var/log|g' \
      -e's|@rundir@|/var/run|g' \
      -e's|@sysconfigdir@|/etc/sysconfig|g' \
      -e's|@initdir@|%{_initscriptdir}|g' \
      -e's|@bindir@|%{_bindir}|g' \
      -e's|@sbindir@|%{_sbindir}|g' \
      -e's|@subsysdir@|/var/lock/subsys|g' \
      -e's|@varlibdir@|/var/lib|g' \
      -e's|@varcachedir@|/var/cache|g' \
      -e's|@logrotatedir@|/etc/logrotate.d|g' \
  < $file.in > $file
done

# Fix /usr/local -> %{_prefix}
perl -pi.local -e's|/usr/local|'%{_prefix}'|g' \
  ./settings.pro \
  ./programs/mythfilldatabase/mythfilldatabase.pro \
  ./setup/setup.pro \
  ./configfiles/mythfilldatabasecron ./FAQ ./README ./UPGRADING \
  ./libs/libmythtv/docs/README \
  ./contrib/mplayernetwork.pl

cat >> settings.pro << EOF
CONFIG += using_alsa
EXTRA_LIBS += -lasound
EOF

cat >> settings.pro << EOF
CONFIG += using_lirc
EXTRA_LIBS += -llirc_client
EOF

cat >> settings.pro << EOF
PREFIX = %{_prefix}
CONFIG -= debug
CONFIG += release
QMAKE_CXXFLAGS_RELEASE += %{optflags}
QMAKE_CXXFLAGS_RELEASE -= -march=pentiumpro
QMAKE_CFLAGS_RELEASE += %{optflags}
QMAKE_CFLAGS_RELEASE -= -march=pentiumpro
EOF

export QTDIR=%{qtdir}
qmake mythtv.pro

%build
export QTDIR=%{qtdir}
%ifnarch %{ix86} x86_64
%configure --disable-mmx
%else
%configure
%endif
%ifnarch %{ix86} x86_64
perl -pi -e 's/DEFINES\ \+\=\ MMX/DEFINES -= MMX/' settings.pro
%endif
make

%install
export QTDIR=%{qtdir}
rm -rf %{buildroot}
for dir in %{_bindir} %{_libdir}/mythtv/filters %{_datadir}/mythtv/themes/blue %{_includedir}/mythtv; do
  mkdir -p %{buildroot}$dir
done
INSTALL_ROOT=%{buildroot}; export INSTALL_ROOT
%makeinstall

install -p setup/setup %{buildroot}%{_bindir}/mythtvsetup
mkdir -p %{buildroot}/var/lib/mythtv
mkdir -p %{buildroot}/var/cache/mythtv
mkdir -p %{buildroot}/var/log/mythtv
mkdir -p %{buildroot}/etc/logrotate.d
mkdir -p %{buildroot}%{_initscriptdir}
mkdir -p %{buildroot}/etc/sysconfig

install -p mythbackend.init %{buildroot}%{_initscriptdir}/mythbackend
install -p mythbackend.sysconfig %{buildroot}/etc/sysconfig/mythbackend
install -p mythbackend.logrotate  %{buildroot}/etc/logrotate.d/mythbackend

# Desktop entries
mkdir -p %{buildroot}%{_datadir}/pixmaps
mkdir -p %{buildroot}%{_datadir}/applications
for file in mythfrontend; do
  install -p %{_sourcedir}/$file.png %{buildroot}%{_datadir}/pixmaps/$file.png
  desktop-file-install --vendor= \
    --dir %{buildroot}%{_datadir}/applications    \
    --add-category X-Red-Hat-Extra                \
    --add-category Application                    \
    --add-category AudioVideo                     \
    %{_sourcedir}/$file.desktop
done

mkdir -p %{buildroot}%{_libdir}/mythtv/plugins

mkdir -p %{buildroot}%{_datadir}/mythtv/build/
install -p settings.pro %{buildroot}%{_datadir}/mythtv/build/

# Symbolic links for Japanese fonts
ln -s %{_datadir}/fonts/truetype/japanese/kochi-gothic-subst.ttf %{buildroot}%{_datadir}/mythtv/kochi-gothic-subst.ttf
ln -s %{_datadir}/fonts/truetype/japanese/kochi-mincho-subst.ttf %{buildroot}%{_datadir}/mythtv/kochi-mincho-subst.ttf

%clean
rm -rf %{buildroot}

%pre
# Add the "mythtv" user
/usr/sbin/useradd -c "mythtvbackend User" \
        -s /sbin/nologin -r -d /var/lib/mythtv mythtv 2> /dev/null || :

%post

%post -n libmyth -p /sbin/ldconfig

%postun -n libmyth -p /sbin/ldconfig

%post backend
/sbin/chkconfig --add mythbackend

%preun backend
if [ $1 = 0 ]; then
        /sbin/service mythbackend stop > /dev/null 2>&1
        /sbin/chkconfig --del mythbackend
fi

%files
%defattr(-,root,root,-)
%doc README* UPGRADING AUTHORS COPYING FAQ
%doc database keys.txt
%doc docs/*.html docs/*.txt
%config %{_datadir}/mythtv/mysql.txt

%define ghostattr %attr(0644,root,root) %verify(not md5 size mtime) %ghost %config(missingok,noreplace)

%files backend
%defattr(-,root,root,-)
%{_bindir}/mythbackend
%{_bindir}/mythtvsetup
%{_bindir}/mythfilldatabase
%attr(-,mythtv,mythtv) %dir /var/lib/mythtv
%attr(-,mythtv,mythtv) %dir /var/cache/mythtv
%{_initscriptdir}/mythbackend
%config /etc/sysconfig/mythbackend
%config /etc/logrotate.d/mythbackend
%attr(-,mythtv,mythtv) %dir /var/log/mythtv
# Hm, somehow this doesn't work yet ... :(
#%ghostattr /var/log/mythtv/mythbackend.log*
#%ghostattr /var/run/mythbackend.pid
#%ghostattr /var/lock/subsys/mythbackend

%files frontend
%defattr(-,root,root,-)
%config %{_datadir}/mythtv/*.xml
%{_bindir}/mythfrontend
%{_bindir}/mythtv
%{_bindir}/mythepg
%{_bindir}/mythprogfind
%{_bindir}/mythcommflag
%{_bindir}/mythtranscode
%{_bindir}/mythtvosd
%{_libdir}/mythtv/filters
%{_libdir}/mythtv/plugins
%{_datadir}/mythtv/themes
%{_datadir}/mythtv/*.ttf
%{_datadir}/mythtv/i18n
%{_datadir}/applications/*myth*.desktop
%{_datadir}/pixmaps/myth*.png

%files -n libmyth
%defattr(-,root,root,-)
%{_libdir}/*.so.*

%files -n libmyth-devel
%defattr(-,root,root,-)
%{_includedir}/*
%{_libdir}/*.so
%{_datadir}/mythtv/build/settings.pro

%changelog
* Tue May 18 2006 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.16-11m)
- rebuild against mysql 5.0.22-1m

* Sun Mar 12 2006 Dai OKUYAMA <dai@ouchi.nahi.to>
- (0.16-10m)
- ppc build fix

* Thu Jan 19 2006 Dai OKUYAMA <dai@ouchi.nahi.to>
- (0.16-9m)
- i686 build fix

* Wed Jan 11 2006 Dai OKUYAMA <dai@ouchi.nahi.to>
- (0.16-8m)
- gcc-4.1 build fix

* Thu Oct 20 2005 Dai OKUYAMA <dai@ouchi.nahi.to>
- (0.16-7m)
- enable ia64, ppc64

* Mon Sep  5 2005 YONEKAWA Susumu <yonekawa@mmg.roka.jp>
- (0.16-6m)
- rebuild against for MySQL-4.1.14

* Wed Mar  2 2005 Ichiro Nakai <ichiro@n.email.ne.jp>
- (0.16-5m)
- remove vendor from desktop file

* Mon Feb 28 2005 Dai OKUYAMA <dai@ouchi.nahi.to>
- (0.16-4m)
- enable ppc.

* Fri Feb 11 2005 Dai OKUYAMA <dai@ouchi.nahi.to>
- (0.16-3m)
- enable x86_64.

* Wed Feb  9 2005 Toru Hoshina <t@momonga-linux.org>
- (0.16-2m)
- rebuild with lame.

* Thu Nov 25 2004 Mitsuru Shimamura <smbd@momonga-linux.org>
- (0.16-1m)
- up to 0.16

* Wed May 26 2004 Toru Hoshina <t@momonga-linux.org>
- (0.14-1m)
- import from paken.

* Fri Jan 31 2004 Takeru Komoriya <komoriya@paken.org>
- japanese version based on mythtv-0.13-48.rhfc1.at

* Sat Dec 20 2003 Axel Thimm <Axel.Thimm@physik.fu-berlin.de>
- Patch for missing tvformat default (bttv always did PAL).

* Thu Dec 11 2003 Axel Thimm <Axel.Thimm@physik.fu-berlin.de>
- Update to 0.13.
- Remove ringbuffer patch (applied in 0.13).

* Tue Oct 21 2003 Axel Thimm <Axel.Thimm@physik.fu-berlin.de>
- Add cvs patch fixing ringbuffer races.
- Remove settings patch for alsa/lirc and make it configurable
  from the rpmbuild invocation instead with --with/--without switches
- New qmake invocation.

* Sun Oct 19 2003 Axel Thimm <Axel.Thimm@physik.fu-berlin.de>
- Update to 0.12.
- Move path macros out of specfile.
- Remove imdb patch.
- Silence install/upgrade output.

* Mon Oct 13 2003 Axel Thimm <Axel.Thimm@physik.fu-berlin.de>
- Activate native alsa and lirc modes.

* Sat Sep 20 2003 "Jarod C. Wilson" <jcw@wilsonet.com>
- Added patch for imdb changes.

* Sat Aug 16 2003 Axel Thimm <Axel.Thimm@physik.fu-berlin.de>
- Update to 0.11.

* Wed Jul  2 2003 Axel Thimm <Axel.Thimm@physik.fu-berlin.de>
- Update to 0.10.

* Tue Jun 24 2003 Axel Thimm <Axel.Thimm@physik.fu-berlin.de>
- Make logrotate script accept non-existing logfiles.

* Sat Jun 21 2003 Axel Thimm <Axel.Thimm@physik.fu-berlin.de>
- Split off mythtv-suite.

* Thu Jun 12 2003 Axel Thimm <Axel.Thimm@physik.fu-berlin.de>
- Update to 0.9.1 release.
- Split /var/spool/mythtv to /var/lib/mythtv and /var/cache/mythtv.
  (as Debian does).

* Tue Jun 10 2003 Axel Thimm <Axel.Thimm@physik.fu-berlin.de>
- Update to 0.9 release.

* Wed May 14 2003 Axel Thimm <Axel.Thimm@physik.fu-berlin.de>
- Fixed packaging bug in libmyth-devel.

* Tue Apr  8 2003 Axel Thimm <Axel.Thimm@physik.fu-berlin.de>
- Rebuilt for Red Hat 9.

* Sun Mar 23 2003 Axel Thimm <Axel.Thimm@physik.fu-berlin.de>
- Fixed desktop entries.

* Sat Mar 22 2003 Axel Thimm <Axel.Thimm@physik.fu-berlin.de>
- Add g flag to sed.
- Don't use mythtv user yet.

* Fri Mar 21 2003 Axel Thimm <Axel.Thimm@physik.fu-berlin.de>
- Add mythtv user.
- Add desktop entries.

* Wed Mar 19 2003 Axel Thimm <Axel.Thimm@physik.fu-berlin.de>
- Added start/stop scripts for mythbackend.

* Tue Mar 18 2003 Axel Thimm <Axel.Thimm@physik.fu-berlin.de>
- Removed unneeded 0.7 patches.

* Mon Mar 17 2003 Axel Thimm <Axel.Thimm@physik.fu-berlin.de>
- Update to 0.8.
- Synced with Matt Zimmerman's debian package (package splitting).
- Split off lib, devel, frontend, backend packages.

* Thu Feb 13 2003 Paul Jara <pjara@rogers.com>
- Added a patch that prevents a segmentation fault in mythfilldatabase.

* Thu Jan 16 2003 Axel Thimm <Axel.Thimm@physik.fu-berlin.de>
- Added dependency to qt-MySQL (Roy Stogner <roystgnr@ticam.utexas.edu>).

* Thu Dec  5 2002 Axel Thimm <Axel.Thimm@physik.fu-berlin.de>
- fixed installation paths.

* Wed Nov 13 2002 Axel Thimm <Axel.Thimm@physik.fu-berlin.de>
- Initial build.


